//
//  ZipArchive.h
//  
//
//  Created by aish on 08-9-11.
//  acsolu@gmail.com
//  Copyright 2008  Inc. All rights reserved.
//
// History: 
//    09-11-2008 version 1.0    release
//    10-18-2009 version 1.1    support password protected zip files
//    10-21-2009 version 1.2    fix date bug

#import <UIKit/UIKit.h>

#include "zip.h"
#include "unzip.h"


@protocol ZipArchiveDelegate <NSObject>
@optional
-(void) ErrorMessage:(NSString*) msg;
-(BOOL) OverWriteOperation:(NSString*) file;
-(void) UnzipProgress:(uLong)myCurrentFileIndex total:(uLong)myTotalFileCount;
@end


@interface ZipArchive : NSObject {
@private
    zipFile         _zipFile;
    unzFile         _unzFile;
    
    NSString*   _password;
    uLong _totalFileCount;
    id<ZipArchiveDelegate>                  _delegate;
}

@property (nonatomic, assign) id<ZipArchiveDelegate> delegate;

-(BOOL) CreateZipFile2:(NSString*) zipFile;
-(BOOL) CreateZipFile2:(NSString*) zipFile Password:(NSString*) password;
-(BOOL) addFileToZip:(NSString*) file newname:(NSString*) newname;
-(BOOL) CloseZipFile2;

-(BOOL) UnzipOpenFile:(NSString*) zipFile;
-(BOOL) UnzipOpenFile:(NSString*) zipFile Password:(NSString*) password;
-(BOOL) UnzipFileTo:(NSString*) path overWrite:(BOOL) overwrite;
-(NSMutableArray *) getZipFileContents;
-(BOOL) UnzipCloseFile;
@end
